<template>
  <v-layout align-center justify-center>
    <v-flex md3 sm8 xs11>
      <BaseCard :title="$t('signup.TITLE')">
        <form @submit.prevent="submit">
          <v-layout column>
            <v-flex>
              <v-text-field
                :error="errors.has('name')"
                :error-messages="errors.collect('name')"
                :label="$t('signup.NAME')"
                autocomplete="off"
                data-vv-validate-on="change|blur"
                id="name"
                data-vv-as="Фио"
                name="name"
                v-model="name"
                v-validate="'required'"
              ></v-text-field>
            </v-flex>
            <v-flex>
              <v-text-field
                :error="errors.has('phone')"
                :error-messages="errors.collect('phone')"
                :label="$t('signup.PHONE')"
                autocomplete="off"
                data-vv-validate-on="change|blur"
                id="phones"
                data-vv-as="Телефон"
                name="phone"
                type="phone"
                v-model="phone"
                v-validate="'required|phone'"
              ></v-text-field>
            </v-flex>
            <v-flex>
              <v-text-field
                :error="errors.has('password')"
                :error-messages="errors.collect('password')"
                :label="$t('signup.PASSWORD')"
                autocomplete="off"
                data-vv-validate-on="change|blur"
                id="password"
                data-vv-as="Пароль"
                name="password"
                ref="password"
                type="password"
                v-model="password"
                v-validate="'required|min:5'"
              ></v-text-field>
            </v-flex>
            <v-flex>
              <v-text-field
                :error="errors.has('confirmPassword')"
                :error-messages="errors.collect('confirmPassword')"
                :label="$t('signup.CONFIRM_PASSWORD')"
                autocomplete="off"
                data-vv-validate-on="change|blur"
                id="confirmPassword"
                data-vv-as="Подтверждения пароля"
                name="confirmPassword"
                type="password"
                v-model="confirmPassword"
                v-validate="'required|min:5|confirmed:password'"
              ></v-text-field>
            </v-flex>
            <v-flex text-xs-center>
              <base-button :text="$t('signup.SIGN_ME_UP')" large/>
            </v-flex>
          </v-layout>
        </form>
      </BaseCard>
      </v-flex>
    </v-layout>
</template>

<script>
  import router from '@/router'
  import { mapActions } from 'vuex'
  import BaseButton from '@/components/base/Button'
  import BaseCard from '@/components/base/Card';

  export default {
    components: { BaseCard, BaseButton },
    data () {
      return {
        name: '',
        phone: '',
        password: '',
        confirmPassword: ''
      }
    },
    methods: {
      ...mapActions(['userSignUp', 'updateProfile', 'getToken']),
      async submit () {
        const valid = await this.$validator.validateAll();
        if (valid) {
          this.userSignUp({
            name: this.name,
            phone: this.phone,
            password: this.password
          }).then(() => {
            router.push({ name: 'login' })
          })
        }
      }
    },
    created () {
      if (this.$store.state.auth.isTokenSet) {
        router.push({ name: 'dashboard' })
      }
    }
  }
</script>
